

data Nat : Set where
  zero : Nat
  suc  : Nat -> Nat

infixl 10 +
infixl 12 *

(+) : Nat -> Nat -> Nat
n + 0	    = n
n + suc m  = suc (n + m)

(*) : Nat -> Nat -> Nat
n * 0	  = 0
n * suc m = n * m + n

data Parity : Nat -> Set where
  even : (k : Nat) -> Parity (2 * k)
  odd  : (k : Nat) -> Parity (2 * k + 1)

parSuc : (n : Nat) -> Parity n -> Parity (suc n)
parSuc (2 * k)     (even k) = odd k
parSuc (2 * k + 1) (odd k)  = even (suc k)

parity : (n : Nat) -> Parity n
parity 0	= even 0
parity (suc n)	= parSuc n (parity n)

